//+------------------------------------------------------------------+
//|                                             DidiIndexHedgeEA.mq5 |
//|                                                           suvroc |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "suvroc"
#property link      ""
#property version   "1.00"

#include <myFunctions.mqh>
#include <CustomOptimisation.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
// GLOBAL VARS

sinput group                              "EA GENERAL SETTINGS"
input ulong                               MagicNumber             = 101;
input bool                                UseFillingPolicy        = false;
input ENUM_ORDER_TYPE_FILLING             FillingPolicy           = ORDER_FILLING_FOK;
input double                              minTrades               = 50.0;

sinput group                              "ATR SETTINGS";
input int                                 atrPeriod = 14;
input int                                 shiftAtr  = 0;

sinput group                              "1st CONFIRMATION INDICATOR PARAMETERS";

input int                                 inpKPeriod = 1;
input int                                 inpDPeriod = 3;
input int                                 inpSlowing = 11;
input int                                 inpCCI = 34;
input double                              inpC1 = 0.5;
input double                              inpC2 = 0.5;
input double                              inpC3 = 0.5;
input int                                 inpP = 6;
input int                                 inpMaPeriod = 61;
input ENUM_MA_METHOD                      inpMaMethod = MODE_SMA;
input int                                 inpPeriod = 21;




double      atrValue;
int         atrHandle; 
int         stableFxHandle;

string      entrySignal;
datetime    glTimeBarOpen;
string      indiPath = "StableFx.ex5";   
//---
TCustomCriterionArray   *criterion_Ptr;
//---

int OnInit()
  {
//---
   glTimeBarOpen = D'1971.01.01 00:00';

   atrHandle = iATR(_Symbol,PERIOD_CURRENT,atrPeriod);
   
   stableFxHandle = iCustom(_Symbol,PERIOD_CURRENT, indiPath, inpKPeriod,inpDPeriod,inpSlowing,inpCCI,inpC1,inpC2,inpC3,inpP,inpMaPeriod,inpMaMethod,inpPeriod);
   
   if(stableFxHandle == INVALID_HANDLE)
     {
         Print("FAILED TO INIT DIDI INDEX INDICATOR");
         return (INVALID_HANDLE);
     }
   
   if (atrHandle == INVALID_HANDLE) 
   {
      Print("FAILED TO INIT ATR INDICATOR");
      return (INVALID_HANDLE);
   }
   
   
  // criterion_Ptr=new TCustomCriterionArray();
  // if(CheckPointer(criterion_Ptr)==POINTER_INVALID)
  //   {
   //   return(-1);
   //  }
  // criterion_Ptr.Add( new TSimpleCriterion( STAT_PROFIT ));
  // criterion_Ptr.Add( new TSimpleDivCriterion( STAT_BALANCE_DD ));
  // criterion_Ptr.Add( new TSimpleMinCriterion( STAT_TRADES, minTrades ));
   //criterion_Ptr.Add( new TBalanceSlopeCriterion(Symbol(),100000.0));
   //criterion_Ptr.Add(new TTSSFCriterion());
      
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
      //if(CheckPointer(criterion_Ptr)==POINTER_DYNAMIC)
     //{
     // delete(criterion_Ptr);
    // }
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
//+------------------------------------------------------------------+
//| 1. ATR                                         |
//+------------------------------------------------------------------+
   
   atrValue = NormalizeDouble(myAtr(atrHandle,shiftAtr),_Digits);
   Comment("ATR : ", atrValue);
   
//+------------------------------------------------------------------+
//| 2. TESTED INDICATOR                                              |
//+------------------------------------------------------------------+
      //--------------------//
   //  NEW BAR CONTROL   //
   //--------------------//
   double myIndicator[];
   CopyBuffer(stableFxHandle,0,0,1,myIndicator);
   ArraySetAsSeries(myIndicator, true);
   Print(myIndicator[0]);
   datetime currTime = TimeCurrent(); 
   bool newBar = false;
   double   myBallance = AccountInfoDouble(ACCOUNT_BALANCE);
   double   contractSize = SymbolInfoDouble(_Symbol,SYMBOL_TRADE_CONTRACT_SIZE);
    //Print("current time : " + currTime);
   //Check for New Bar
   if(currTime == (iTime(Symbol(),PERIOD_CURRENT,0) + PeriodSeconds(PERIOD_M30) * 47))
   {
      newBar = true;
      glTimeBarOpen = iTime(Symbol(),PERIOD_CURRENT,0) + PeriodSeconds(PERIOD_M30) * 47;   
   }   
   
   if(newBar == true)
   {  
     
      //double myBuffer[];
      //CopyBuffer(didiHandle,2,0,2,myBuffer);
     // bool cross = DetectCrossover(myBuffer,2);
      //Print("DIDI SIGNAL : ", myBuffer[1]);
      
      double   myLot =  ((myBallance * 0.02) / (atrValue * 1.5)) / 100000;
      
      entrySignal = detectCrossover(stableFxHandle, 0, 1, glTimeBarOpen);

      
      
      Comment("EA #", MagicNumber, " | ",entrySignal, " SIGNALS DETECTED");
      
      if((entrySignal == "LONG" || entrySignal == "SHORT") && CheckPlacedPositions(MagicNumber) == false)
      {
         
         ulong ticket = OpenTrades(entrySignal,MagicNumber,NormalizeDouble(myLot,2), UseFillingPolicy, FillingPolicy);  
         
         //SL & TP Trade Modification
         if(ticket > 0)
         {
            double stopLoss = CalculateStopLoss(entrySignal, atrValue * 1.5);
            double takeProfit = CalculateTakeProfit(entrySignal, atrValue);
            TradeModification(ticket,MagicNumber,stopLoss,takeProfit);         
         }
      }
      else if((entrySignal == "LONG" || entrySignal == "SHORT"))
       {
         Print(entrySignal + " without position check" );
       }
      else
        {
         Print(entrySignal);
        }
            


              
      
   
   }
//+------------------------------------------------------------------+
//| 2. ORDER MANAGEMENT                                              |
//+------------------------------------------------------------------+

  }
//+------------------------------------------------------------------+
double  OnTester()
  {
   double   param=0.0;

//	Balance max + min Drawdown + Trades Number:
   //if(CheckPointer(criterion_Ptr)!=POINTER_INVALID)
    // {
    //  param=criterion_Ptr.GetCriterion();
    // }

   //return(param);
   double winTrades = TesterStatistics(STAT_PROFIT_TRADES);
   double lossTrades = TesterStatistics(STAT_LOSS_TRADES);
   double winLossPercent = (winTrades+lossTrades) > 0? winTrades / (winTrades+lossTrades) * 100.0 : 0;
   return (winLossPercent);
  }